---
product: "AG Grid"
title: "Accessibility"
description: "AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations."
framework: angular
version: "36.2.0"
related:
    - title: "Keyboard Navigation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/keyboard-navigation/"
    - title: "Touch"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/touch/"
    - title: "Input Fields"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/input-fields/"
    - title: "RTL Text Direction"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/rtl/"
    - title: "Aligned Grids"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aligned-grids/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/localisation/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Accessibility

AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations.

## Web Conformance Guidelines

Even if you are not mandated to conform to any particular accessibility standard, it can be helpful to understand the guidelines outlined as they are generally good practices worth incorporating into your web based applications.

Currently the most commonly encountered conformance guidelines are:

- [ADA](https://www.ada.gov/) - US Department of Justice
- [Section 508](https://www.section508.gov/) - US federal agencies
- [WCAG 2.0](https://www.w3.org/WAI/intro/wcag) - globally accepted standard

WCAG 2.0 has 3 levels of conformance; A, AA and AAA (in order of conformance)

As meeting WCAG 2.0 level AA guidelines also meets the ADA and Section 508 standards, it is likely that most organisations will want to target this standard.

## High Contrast Theme

For users who are visually impaired due to colour deficiencies, care should be taken when using colours to provide information.

Using our demo page as an example, the chrome plugin [Colorblindly](https://chrome.google.com/webstore/detail/colorblindly/floniaahmccleoclneebhhmnjgdfijgg/related?hl=en) shows how cells with colour indicators might appear to someone with total colour blindness (Monochromacy / Achromatopsia).

![High Contrast Theme](https://www.ag-grid.com/archive/36.2.0/_astro/accessibility-colour-contrast.gHTZCXOz.png)

To create a high contrast theme please check out the [Themes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/themes/) documentation for details.

## Keyboard navigation

Users who have motor disabilities, as well as visually impaired users, often rely on keyboards for navigation.

For details on how to navigate the grid without using a mouse refer to the [Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/keyboard-navigation/) documentation. Note that it is possible to provide custom navigation which could come in useful for some accessibility requirements.

## Screen Readers

Users who are visually impaired will typically require the assistance of a screen reader to interpret and interact with grid based application.

There are numerous screen readers available, however right now the most popular screen reader for Windows is [JAWS](https://www.freedomscientific.com/Downloads/JAWS) and for MAC users it is the embedded [VoiceOver](http://help.apple.com/voiceover/info/guide) software. Our testing has focused on these screen readers.

In order to cover the widest range of use cases and screen readers, AG Grid has taken a standards-based approach to implementing accessibility support. Instead of optimising our implementation for specific screen readers, we have followed the W3C WCAG standard and added the relevant ARIA-tags to let screen readers announce any AG Grid element and its state.

However, different screen readers interpret the WCAG standard in different ways. As a result, they may generate different announcements for the same AG Grid element, or no announcement at all.

This is why we recommend testing how different screen readers announce the UI of the application you're using, selecting the best one and recommending that to your users. We believe this is the best way to guide your users how to get the best possible experience at this time until screen readers improve their support for the WCAG standard.

## ARIA Attributes

In order to give screen readers the contextual information they require to interpret and interact with the grid, [ARIA](https://www.w3.org/TR/wai-aria/) attributes are added to the grid DOM elements. These attributes are particularity useful when plain HTML elements such `div` and `span` are used to create complex DOM structures, which is the case with AG Grid.

When inspecting the DOM you'll notice the following roles and properties have been added:

- **role="treegrid"** / **role="grid"** - marks the enclosing element of the grid. The grid has `role="treegrid"` when using [Tree Data](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tree-data/) or the grid has [Row Grouping](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping/) applied. In other cases, when providing flat data or using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/master-detail/), the grid has `role="grid"`.

  **Note:** You can set any aria property in the panel (role="treegrid") by using the `setGridAriaProperty` method in the [Grid Api](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-api/).
  - **aria-rowcount** - announces the number of rows.
  - **aria-colcount** - announces the number of columns.
  - **aria-multiselectable="true"** - marks the grid as being able to select multiple rows.
- **role="rowgroup"** - element that serve as container for the table header rows and grid rows.
- **role="row"** - a row of column headers or grid cells.
  - **aria-rowindex** - announces the visible index of the row.
  - **aria-selected** - only present if the row is selectable, it announces the selection state.
  - **aria-expanded** - only present in row groups, it announces the expand state.
- **role="columnheader"** - element containing a column header.
  - **aria-colindex** - announces the visible index of the column.
  - **aria-colspan** - only present if the column spans across multiple columns, it helps guide screen readers.
  - **aria-expanded** - only present in grouped headers, it announces the expand state.
  - **aria-sort** - only present in sortable columns, it announces the sort state.
- **role="gridcell"** - element containing a grid cell.
  - **aria-colindex** - announces the visible index of the cell.
  - **aria-selected** - only present if the cell is selectable, it announces the selection state.
  - **aria-expanded** - only present in a group cell, it announces the expand state.
- **role="tablist"** - element that serve as a container for a single levels of tab items.
- **role="tab"** - marks an element as a tablist item.
- **role="tree"** - element that serve as a container for items that could have multiple levels.
- **role="treeitem"** - marks an element as an item of a tree.
  - **aria-level** - announces the current level of the tree.
  - **aria-expanded** - only present if the item has subitems, it announces the current expand state.
- **role="listbox"** - element that serve as a container for multiple elements that will be presented as a list.
- **role="option"** - marks an element as an item of a listbox.
  - **aria-setsize** - announces the total number of items in the listbox.
  - **aria-posinset** - announces the position of the item within the set.
  - **aria-selected** - only present if the item is selectable, it announces the current select state.
  - **aria-checked** - only present if the item has a checkbox, it announces the current check state.
- **role="presentation"** - indicates an element should be ignored.
- **aria-hidden="true"** - indicates an element and child elements should be ignored.
- **aria-label** - used to provide information about the current focused item.
- **aria-labelledby** - used to provide the id of an element that has the label for the current focused element.
- **aria-describedby** - used to provide additional information about the current selected item.

These attributes will enable screen readers to interpret and navigate the columns and rows of the grid.

> **Note**
>
> Some other grids claim to provide support for complex grid layouts and interactions but based on our own independent testing and the feedback we've received from our users this is clearly not the case.

## Customising the Grid for Accessibility

In order to support large datasets with a minimised memory footprint and a responsive user experience, the grid uses row and column virtualisation, loading new rows and columns as they're needed. However, screen readers assume all elements of the grid are loaded when the page is loaded and they appear in the DOM in order of their visual appearance. In order to meet these requirements, we recommend making the following changes.

### Ensure DOM Element order

By default, rows and columns can appear out of order in the DOM. This 'incorrect order' can result in inconsistent results when parsed by screen readers.

To force row and column order, enable the following gridOptions property like so:

```ts
<ag-grid-angular
    [ensureDomOrder]="ensureDomOrder"
    /* other grid options ... */ />

this.ensureDomOrder = true;
```

### Disable Group Sticky Rows

By default, when grouping, the current parent of rows becomes "sticky" to the top of the grid while scrolling. This causes the rows to be in 'incorrect order' and result in inconsistent announcements for row indices when parsed by screen readers.

To disable Group Sticky Rows, set `suppressGroupRowsSticky={true}` the gridOptions like so:

```ts
<ag-grid-angular
    [suppressGroupRowsSticky]="suppressGroupRowsSticky"
    /* other grid options ... */ />

this.suppressGroupRowsSticky = true;
```

> **Note**
>
> Animations won't work properly when the DOM order is forced, so ensure they are not enabled.

### Ensure all grid elements are always rendered

In order to ensure all grid elements are loaded, you need to disable column and row virtualization. The best way to do this is to use [pagination](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-pagination/). This way you can reduce the initial loading time and memory footprint while ensuring all elements for these rows are loaded for screen readers.

If your requirement is to use scrolling instead of pagination, you can disable row virtualisation at the expense of increasing the memory footprint. Please test the performance of this and if it's not satisfactory, switch to using pagination instead.

Column virtualisation can be disabled as follows:

```ts
<ag-grid-angular
    [suppressColumnVirtualisation]="suppressColumnVirtualisation"
    /* other grid options ... */ />

this.suppressColumnVirtualisation = true;
```

This means if you have 100 columns, but only 10 visible due to scrolling, all 100 will always be rendered.

Row virtualisation can be disabled as follows:

```ts
<ag-grid-angular
    [suppressRowVirtualisation]="suppressRowVirtualisation"
    /* other grid options ... */ />

this.suppressRowVirtualisation = true;
```

However note that lots of rendered rows will mean a very large amount of rendering in the DOM which will slow things down.

## Example of Grid Customised for Accessibility

The example below presents a simple grid layout with the following properties enabled:

- `ensureDomOrder` - ensures the rows and columns in the DOM always appear in the same order as displayed in the grid.
- `suppressColumnVirtualisation` and `suppressRowVirtualisation` - ensure all column and rows appear in the DOM.

#### Grid Customised for Accessibility

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [ensureDomOrder]="true"
    [suppressColumnVirtualisation]="true"
    [suppressRowVirtualisation]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", minWidth: 50, filter: "agNumberColumnFilter" },
    { field: "country", width: 120 },
    { field: "year", width: 90 },
    { field: "date", width: 110 },
    { field: "sport", width: 110 },
    { field: "gold", width: 110 },
    { field: "silver", width: 110 },
    { field: "bronze", width: 110 },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data.slice(0, 600)));
  }
}
```

[Live example: Grid Customised for Accessibility](https://www.ag-grid.com/archive/36.2.0/examples/accessibility/accessibility/angular/)

## Customising ARIA Labels

The grid has default ARIA labels for areas like `rows`, `group cells`, `filters`, `search fields` and so on. If there is a need to customise these labels, this could be achieved by changing the [localisation variables](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/localisation/) for ARIA. See the [localisation example](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/localisation/#customising-a-provided-locale), inspect the items or use a screen reader to see the customisation in action.

## Known Limitations

Using advanced functionality in AG Grid makes the DOM structure incompatible with the assumptions screen readers make. This results in a few limitations in accessibility when specific functionality is used:

- ### Limitations in announcing the correct column name in grouped columns

  Even though all aria tags have been applied to the necessary elements, some screen readers have trouble navigating the tags when the structure of the grid gets more complex (eg. grouped columns). This is the reason why there are some limitations announcing the correct column names.
- ### No announcements of state change of a gridcell or gridheader

  Some screen readers will not recognise changes that happen to an element that is currently focused (including children of this element). So in order to detect changes (eg. sorted state, updated labels, etc...) you will need to move focus to another element and back.
- ### Server-side row model

  Announcing the row count in the grid when using server-side row model (SSRM) is not supported. This is because the row count cannot be known in all the scenarios where SSRM is in use.


---
product: "AG Grid"
title: "Accessibility"
description: "AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations."
framework: vue
version: "36.2.0"
related:
    - title: "Keyboard Navigation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/keyboard-navigation/"
    - title: "Touch"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/touch/"
    - title: "Input Fields"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/input-fields/"
    - title: "RTL Text Direction"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/rtl/"
    - title: "Aligned Grids"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aligned-grids/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/localisation/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Accessibility

AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations.

## Web Conformance Guidelines

Even if you are not mandated to conform to any particular accessibility standard, it can be helpful to understand the guidelines outlined as they are generally good practices worth incorporating into your web based applications.

Currently the most commonly encountered conformance guidelines are:

- [ADA](https://www.ada.gov/) - US Department of Justice
- [Section 508](https://www.section508.gov/) - US federal agencies
- [WCAG 2.0](https://www.w3.org/WAI/intro/wcag) - globally accepted standard

WCAG 2.0 has 3 levels of conformance; A, AA and AAA (in order of conformance)

As meeting WCAG 2.0 level AA guidelines also meets the ADA and Section 508 standards, it is likely that most organisations will want to target this standard.

## High Contrast Theme

For users who are visually impaired due to colour deficiencies, care should be taken when using colours to provide information.

Using our demo page as an example, the chrome plugin [Colorblindly](https://chrome.google.com/webstore/detail/colorblindly/floniaahmccleoclneebhhmnjgdfijgg/related?hl=en) shows how cells with colour indicators might appear to someone with total colour blindness (Monochromacy / Achromatopsia).

![High Contrast Theme](https://www.ag-grid.com/archive/36.2.0/_astro/accessibility-colour-contrast.gHTZCXOz.png)

To create a high contrast theme please check out the [Themes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/themes/) documentation for details.

## Keyboard navigation

Users who have motor disabilities, as well as visually impaired users, often rely on keyboards for navigation.

For details on how to navigate the grid without using a mouse refer to the [Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/keyboard-navigation/) documentation. Note that it is possible to provide custom navigation which could come in useful for some accessibility requirements.

## Screen Readers

Users who are visually impaired will typically require the assistance of a screen reader to interpret and interact with grid based application.

There are numerous screen readers available, however right now the most popular screen reader for Windows is [JAWS](https://www.freedomscientific.com/Downloads/JAWS) and for MAC users it is the embedded [VoiceOver](http://help.apple.com/voiceover/info/guide) software. Our testing has focused on these screen readers.

In order to cover the widest range of use cases and screen readers, AG Grid has taken a standards-based approach to implementing accessibility support. Instead of optimising our implementation for specific screen readers, we have followed the W3C WCAG standard and added the relevant ARIA-tags to let screen readers announce any AG Grid element and its state.

However, different screen readers interpret the WCAG standard in different ways. As a result, they may generate different announcements for the same AG Grid element, or no announcement at all.

This is why we recommend testing how different screen readers announce the UI of the application you're using, selecting the best one and recommending that to your users. We believe this is the best way to guide your users how to get the best possible experience at this time until screen readers improve their support for the WCAG standard.

## ARIA Attributes

In order to give screen readers the contextual information they require to interpret and interact with the grid, [ARIA](https://www.w3.org/TR/wai-aria/) attributes are added to the grid DOM elements. These attributes are particularity useful when plain HTML elements such `div` and `span` are used to create complex DOM structures, which is the case with AG Grid.

When inspecting the DOM you'll notice the following roles and properties have been added:

- **role="treegrid"** / **role="grid"** - marks the enclosing element of the grid. The grid has `role="treegrid"` when using [Tree Data](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tree-data/) or the grid has [Row Grouping](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping/) applied. In other cases, when providing flat data or using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/master-detail/), the grid has `role="grid"`.

  **Note:** You can set any aria property in the panel (role="treegrid") by using the `setGridAriaProperty` method in the [Grid Api](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-api/).
  - **aria-rowcount** - announces the number of rows.
  - **aria-colcount** - announces the number of columns.
  - **aria-multiselectable="true"** - marks the grid as being able to select multiple rows.
- **role="rowgroup"** - element that serve as container for the table header rows and grid rows.
- **role="row"** - a row of column headers or grid cells.
  - **aria-rowindex** - announces the visible index of the row.
  - **aria-selected** - only present if the row is selectable, it announces the selection state.
  - **aria-expanded** - only present in row groups, it announces the expand state.
- **role="columnheader"** - element containing a column header.
  - **aria-colindex** - announces the visible index of the column.
  - **aria-colspan** - only present if the column spans across multiple columns, it helps guide screen readers.
  - **aria-expanded** - only present in grouped headers, it announces the expand state.
  - **aria-sort** - only present in sortable columns, it announces the sort state.
- **role="gridcell"** - element containing a grid cell.
  - **aria-colindex** - announces the visible index of the cell.
  - **aria-selected** - only present if the cell is selectable, it announces the selection state.
  - **aria-expanded** - only present in a group cell, it announces the expand state.
- **role="tablist"** - element that serve as a container for a single levels of tab items.
- **role="tab"** - marks an element as a tablist item.
- **role="tree"** - element that serve as a container for items that could have multiple levels.
- **role="treeitem"** - marks an element as an item of a tree.
  - **aria-level** - announces the current level of the tree.
  - **aria-expanded** - only present if the item has subitems, it announces the current expand state.
- **role="listbox"** - element that serve as a container for multiple elements that will be presented as a list.
- **role="option"** - marks an element as an item of a listbox.
  - **aria-setsize** - announces the total number of items in the listbox.
  - **aria-posinset** - announces the position of the item within the set.
  - **aria-selected** - only present if the item is selectable, it announces the current select state.
  - **aria-checked** - only present if the item has a checkbox, it announces the current check state.
- **role="presentation"** - indicates an element should be ignored.
- **aria-hidden="true"** - indicates an element and child elements should be ignored.
- **aria-label** - used to provide information about the current focused item.
- **aria-labelledby** - used to provide the id of an element that has the label for the current focused element.
- **aria-describedby** - used to provide additional information about the current selected item.

These attributes will enable screen readers to interpret and navigate the columns and rows of the grid.

> **Note**
>
> Some other grids claim to provide support for complex grid layouts and interactions but based on our own independent testing and the feedback we've received from our users this is clearly not the case.

## Customising the Grid for Accessibility

In order to support large datasets with a minimised memory footprint and a responsive user experience, the grid uses row and column virtualisation, loading new rows and columns as they're needed. However, screen readers assume all elements of the grid are loaded when the page is loaded and they appear in the DOM in order of their visual appearance. In order to meet these requirements, we recommend making the following changes.

### Ensure DOM Element order

By default, rows and columns can appear out of order in the DOM. This 'incorrect order' can result in inconsistent results when parsed by screen readers.

To force row and column order, enable the following gridOptions property like so:

```ts
<ag-grid-vue
    :ensureDomOrder="ensureDomOrder"
    /* other grid options ... */>
</ag-grid-vue>

this.ensureDomOrder = true;
```

### Disable Group Sticky Rows

By default, when grouping, the current parent of rows becomes "sticky" to the top of the grid while scrolling. This causes the rows to be in 'incorrect order' and result in inconsistent announcements for row indices when parsed by screen readers.

To disable Group Sticky Rows, set `suppressGroupRowsSticky={true}` the gridOptions like so:

```ts
<ag-grid-vue
    :suppressGroupRowsSticky="suppressGroupRowsSticky"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressGroupRowsSticky = true;
```

> **Note**
>
> Animations won't work properly when the DOM order is forced, so ensure they are not enabled.

### Ensure all grid elements are always rendered

In order to ensure all grid elements are loaded, you need to disable column and row virtualization. The best way to do this is to use [pagination](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-pagination/). This way you can reduce the initial loading time and memory footprint while ensuring all elements for these rows are loaded for screen readers.

If your requirement is to use scrolling instead of pagination, you can disable row virtualisation at the expense of increasing the memory footprint. Please test the performance of this and if it's not satisfactory, switch to using pagination instead.

Column virtualisation can be disabled as follows:

```ts
<ag-grid-vue
    :suppressColumnVirtualisation="suppressColumnVirtualisation"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressColumnVirtualisation = true;
```

This means if you have 100 columns, but only 10 visible due to scrolling, all 100 will always be rendered.

Row virtualisation can be disabled as follows:

```ts
<ag-grid-vue
    :suppressRowVirtualisation="suppressRowVirtualisation"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressRowVirtualisation = true;
```

However note that lots of rendered rows will mean a very large amount of rendering in the DOM which will slow things down.

## Example of Grid Customised for Accessibility

The example below presents a simple grid layout with the following properties enabled:

- `ensureDomOrder` - ensures the rows and columns in the DOM always appear in the same order as displayed in the grid.
- `suppressColumnVirtualisation` and `suppressRowVirtualisation` - ensure all column and rows appear in the DOM.

#### Grid Customised for Accessibility

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :ensureDomOrder="true"
      :suppressColumnVirtualisation="true"
      :suppressRowVirtualisation="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", minWidth: 50, filter: "agNumberColumnFilter" },
      { field: "country", width: 120 },
      { field: "year", width: 90 },
      { field: "date", width: 110 },
      { field: "sport", width: 110 },
      { field: "gold", width: 110 },
      { field: "silver", width: 110 },
      { field: "bronze", width: 110 },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data.slice(0, 600));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Grid Customised for Accessibility](https://www.ag-grid.com/archive/36.2.0/examples/accessibility/accessibility/vue3/)

## Customising ARIA Labels

The grid has default ARIA labels for areas like `rows`, `group cells`, `filters`, `search fields` and so on. If there is a need to customise these labels, this could be achieved by changing the [localisation variables](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/localisation/) for ARIA. See the [localisation example](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/localisation/#customising-a-provided-locale), inspect the items or use a screen reader to see the customisation in action.

## Known Limitations

Using advanced functionality in AG Grid makes the DOM structure incompatible with the assumptions screen readers make. This results in a few limitations in accessibility when specific functionality is used:

- ### Limitations in announcing the correct column name in grouped columns

  Even though all aria tags have been applied to the necessary elements, some screen readers have trouble navigating the tags when the structure of the grid gets more complex (eg. grouped columns). This is the reason why there are some limitations announcing the correct column names.
- ### No announcements of state change of a gridcell or gridheader

  Some screen readers will not recognise changes that happen to an element that is currently focused (including children of this element). So in order to detect changes (eg. sorted state, updated labels, etc...) you will need to move focus to another element and back.
- ### Server-side row model

  Announcing the row count in the grid when using server-side row model (SSRM) is not supported. This is because the row count cannot be known in all the scenarios where SSRM is in use.


---
product: "AG Grid"
title: "Accessibility"
description: "AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations."
framework: react
version: "36.2.0"
related:
    - title: "Keyboard Navigation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/keyboard-navigation/"
    - title: "Touch"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/touch/"
    - title: "Input Fields"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/input-fields/"
    - title: "RTL Text Direction"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/rtl/"
    - title: "Aligned Grids"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aligned-grids/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/localisation/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Accessibility

AG Grid provides amongst the best support for accessibility compared to other grids available on the market today. This page provides guidance on how to address accessibility concerns in your grid implementations.

## Web Conformance Guidelines

Even if you are not mandated to conform to any particular accessibility standard, it can be helpful to understand the guidelines outlined as they are generally good practices worth incorporating into your web based applications.

Currently the most commonly encountered conformance guidelines are:

- [ADA](https://www.ada.gov/) - US Department of Justice
- [Section 508](https://www.section508.gov/) - US federal agencies
- [WCAG 2.0](https://www.w3.org/WAI/intro/wcag) - globally accepted standard

WCAG 2.0 has 3 levels of conformance; A, AA and AAA (in order of conformance)

As meeting WCAG 2.0 level AA guidelines also meets the ADA and Section 508 standards, it is likely that most organisations will want to target this standard.

## High Contrast Theme

For users who are visually impaired due to colour deficiencies, care should be taken when using colours to provide information.

Using our demo page as an example, the chrome plugin [Colorblindly](https://chrome.google.com/webstore/detail/colorblindly/floniaahmccleoclneebhhmnjgdfijgg/related?hl=en) shows how cells with colour indicators might appear to someone with total colour blindness (Monochromacy / Achromatopsia).

![High Contrast Theme](https://www.ag-grid.com/archive/36.2.0/_astro/accessibility-colour-contrast.gHTZCXOz.png)

To create a high contrast theme please check out the [Themes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/themes/) documentation for details.

## Keyboard navigation

Users who have motor disabilities, as well as visually impaired users, often rely on keyboards for navigation.

For details on how to navigate the grid without using a mouse refer to the [Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/keyboard-navigation/) documentation. Note that it is possible to provide custom navigation which could come in useful for some accessibility requirements.

## Screen Readers

Users who are visually impaired will typically require the assistance of a screen reader to interpret and interact with grid based application.

There are numerous screen readers available, however right now the most popular screen reader for Windows is [JAWS](https://www.freedomscientific.com/Downloads/JAWS) and for MAC users it is the embedded [VoiceOver](http://help.apple.com/voiceover/info/guide) software. Our testing has focused on these screen readers.

In order to cover the widest range of use cases and screen readers, AG Grid has taken a standards-based approach to implementing accessibility support. Instead of optimising our implementation for specific screen readers, we have followed the W3C WCAG standard and added the relevant ARIA-tags to let screen readers announce any AG Grid element and its state.

However, different screen readers interpret the WCAG standard in different ways. As a result, they may generate different announcements for the same AG Grid element, or no announcement at all.

This is why we recommend testing how different screen readers announce the UI of the application you're using, selecting the best one and recommending that to your users. We believe this is the best way to guide your users how to get the best possible experience at this time until screen readers improve their support for the WCAG standard.

## ARIA Attributes

In order to give screen readers the contextual information they require to interpret and interact with the grid, [ARIA](https://www.w3.org/TR/wai-aria/) attributes are added to the grid DOM elements. These attributes are particularity useful when plain HTML elements such `div` and `span` are used to create complex DOM structures, which is the case with AG Grid.

When inspecting the DOM you'll notice the following roles and properties have been added:

- **role="treegrid"** / **role="grid"** - marks the enclosing element of the grid. The grid has `role="treegrid"` when using [Tree Data](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tree-data/) or the grid has [Row Grouping](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping/) applied. In other cases, when providing flat data or using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/react-data-grid/master-detail/), the grid has `role="grid"`.

  **Note:** You can set any aria property in the panel (role="treegrid") by using the `setGridAriaProperty` method in the [Grid Api](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-api/).
  - **aria-rowcount** - announces the number of rows.
  - **aria-colcount** - announces the number of columns.
  - **aria-multiselectable="true"** - marks the grid as being able to select multiple rows.
- **role="rowgroup"** - element that serve as container for the table header rows and grid rows.
- **role="row"** - a row of column headers or grid cells.
  - **aria-rowindex** - announces the visible index of the row.
  - **aria-selected** - only present if the row is selectable, it announces the selection state.
  - **aria-expanded** - only present in row groups, it announces the expand state.
- **role="columnheader"** - element containing a column header.
  - **aria-colindex** - announces the visible index of the column.
  - **aria-colspan** - only present if the column spans across multiple columns, it helps guide screen readers.
  - **aria-expanded** - only present in grouped headers, it announces the expand state.
  - **aria-sort** - only present in sortable columns, it announces the sort state.
- **role="gridcell"** - element containing a grid cell.
  - **aria-colindex** - announces the visible index of the cell.
  - **aria-selected** - only present if the cell is selectable, it announces the selection state.
  - **aria-expanded** - only present in a group cell, it announces the expand state.
- **role="tablist"** - element that serve as a container for a single levels of tab items.
- **role="tab"** - marks an element as a tablist item.
- **role="tree"** - element that serve as a container for items that could have multiple levels.
- **role="treeitem"** - marks an element as an item of a tree.
  - **aria-level** - announces the current level of the tree.
  - **aria-expanded** - only present if the item has subitems, it announces the current expand state.
- **role="listbox"** - element that serve as a container for multiple elements that will be presented as a list.
- **role="option"** - marks an element as an item of a listbox.
  - **aria-setsize** - announces the total number of items in the listbox.
  - **aria-posinset** - announces the position of the item within the set.
  - **aria-selected** - only present if the item is selectable, it announces the current select state.
  - **aria-checked** - only present if the item has a checkbox, it announces the current check state.
- **role="presentation"** - indicates an element should be ignored.
- **aria-hidden="true"** - indicates an element and child elements should be ignored.
- **aria-label** - used to provide information about the current focused item.
- **aria-labelledby** - used to provide the id of an element that has the label for the current focused element.
- **aria-describedby** - used to provide additional information about the current selected item.

These attributes will enable screen readers to interpret and navigate the columns and rows of the grid.

> **Note**
>
> Some other grids claim to provide support for complex grid layouts and interactions but based on our own independent testing and the feedback we've received from our users this is clearly not the case.

## Customising the Grid for Accessibility

In order to support large datasets with a minimised memory footprint and a responsive user experience, the grid uses row and column virtualisation, loading new rows and columns as they're needed. However, screen readers assume all elements of the grid are loaded when the page is loaded and they appear in the DOM in order of their visual appearance. In order to meet these requirements, we recommend making the following changes.

### Ensure DOM Element order

By default, rows and columns can appear out of order in the DOM. This 'incorrect order' can result in inconsistent results when parsed by screen readers.

To force row and column order, enable the following gridOptions property like so:

```jsx
const ensureDomOrder = true;

<AgGridReact ensureDomOrder={ensureDomOrder} />
```

### Disable Group Sticky Rows

By default, when grouping, the current parent of rows becomes "sticky" to the top of the grid while scrolling. This causes the rows to be in 'incorrect order' and result in inconsistent announcements for row indices when parsed by screen readers.

To disable Group Sticky Rows, set `suppressGroupRowsSticky={true}` the gridOptions like so:

```jsx
const suppressGroupRowsSticky = true;

<AgGridReact suppressGroupRowsSticky={suppressGroupRowsSticky} />
```

> **Note**
>
> Animations won't work properly when the DOM order is forced, so ensure they are not enabled.

### Ensure all grid elements are always rendered

In order to ensure all grid elements are loaded, you need to disable column and row virtualization. The best way to do this is to use [pagination](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-pagination/). This way you can reduce the initial loading time and memory footprint while ensuring all elements for these rows are loaded for screen readers.

If your requirement is to use scrolling instead of pagination, you can disable row virtualisation at the expense of increasing the memory footprint. Please test the performance of this and if it's not satisfactory, switch to using pagination instead.

Column virtualisation can be disabled as follows:

```jsx
const suppressColumnVirtualisation = true;

<AgGridReact suppressColumnVirtualisation={suppressColumnVirtualisation} />
```

This means if you have 100 columns, but only 10 visible due to scrolling, all 100 will always be rendered.

Row virtualisation can be disabled as follows:

```jsx
const suppressRowVirtualisation = true;

<AgGridReact suppressRowVirtualisation={suppressRowVirtualisation} />
```

However note that lots of rendered rows will mean a very large amount of rendering in the DOM which will slow things down.

## Example of Grid Customised for Accessibility

The example below presents a simple grid layout with the following properties enabled:

- `ensureDomOrder` - ensures the rows and columns in the DOM always appear in the same order as displayed in the grid.
- `suppressColumnVirtualisation` and `suppressRowVirtualisation` - ensure all column and rows appear in the DOM.

#### Grid Customised for Accessibility

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", minWidth: 50, filter: "agNumberColumnFilter" },
    { field: "country", width: 120 },
    { field: "year", width: 90 },
    { field: "date", width: 110 },
    { field: "sport", width: 110 },
    { field: "gold", width: 110 },
    { field: "silver", width: 110 },
    { field: "bronze", width: 110 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
    600,
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            ensureDomOrder={true}
            suppressColumnVirtualisation={true}
            suppressRowVirtualisation={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Grid Customised for Accessibility](https://www.ag-grid.com/archive/36.2.0/examples/accessibility/accessibility/reactFunctionalTs/)

## Customising ARIA Labels

The grid has default ARIA labels for areas like `rows`, `group cells`, `filters`, `search fields` and so on. If there is a need to customise these labels, this could be achieved by changing the [localisation variables](https://www.ag-grid.com/archive/36.2.0/react-data-grid/localisation/) for ARIA. See the [localisation example](https://www.ag-grid.com/archive/36.2.0/react-data-grid/localisation/#customising-a-provided-locale), inspect the items or use a screen reader to see the customisation in action.

## Known Limitations

Using advanced functionality in AG Grid makes the DOM structure incompatible with the assumptions screen readers make. This results in a few limitations in accessibility when specific functionality is used:

- ### Limitations in announcing the correct column name in grouped columns

  Even though all aria tags have been applied to the necessary elements, some screen readers have trouble navigating the tags when the structure of the grid gets more complex (eg. grouped columns). This is the reason why there are some limitations announcing the correct column names.
- ### No announcements of state change of a gridcell or gridheader

  Some screen readers will not recognise changes that happen to an element that is currently focused (including children of this element). So in order to detect changes (eg. sorted state, updated labels, etc...) you will need to move focus to another element and back.
- ### Server-side row model

  Announcing the row count in the grid when using server-side row model (SSRM) is not supported. This is because the row count cannot be known in all the scenarios where SSRM is in use.
